/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the CampaignSendoutSplitInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CampaignSendoutSplitInner{}

// CampaignSendoutSplitInner struct for CampaignSendoutSplitInner
type CampaignSendoutSplitInner struct {
	Amount *int32 `json:"amount,omitempty"`
	Status *string `json:"status,omitempty"`
}

// NewCampaignSendoutSplitInner instantiates a new CampaignSendoutSplitInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCampaignSendoutSplitInner() *CampaignSendoutSplitInner {
	this := CampaignSendoutSplitInner{}
	return &this
}

// NewCampaignSendoutSplitInnerWithDefaults instantiates a new CampaignSendoutSplitInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCampaignSendoutSplitInnerWithDefaults() *CampaignSendoutSplitInner {
	this := CampaignSendoutSplitInner{}
	return &this
}

// GetAmount returns the Amount field value if set, zero value otherwise.
func (o *CampaignSendoutSplitInner) GetAmount() int32 {
	if o == nil || IsNil(o.Amount) {
		var ret int32
		return ret
	}
	return *o.Amount
}

// GetAmountOk returns a tuple with the Amount field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendoutSplitInner) GetAmountOk() (*int32, bool) {
	if o == nil || IsNil(o.Amount) {
		return nil, false
	}
	return o.Amount, true
}

// HasAmount returns a boolean if a field has been set.
func (o *CampaignSendoutSplitInner) HasAmount() bool {
	if o != nil && !IsNil(o.Amount) {
		return true
	}

	return false
}

// SetAmount gets a reference to the given int32 and assigns it to the Amount field.
func (o *CampaignSendoutSplitInner) SetAmount(v int32) {
	o.Amount = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *CampaignSendoutSplitInner) GetStatus() string {
	if o == nil || IsNil(o.Status) {
		var ret string
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CampaignSendoutSplitInner) GetStatusOk() (*string, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *CampaignSendoutSplitInner) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given string and assigns it to the Status field.
func (o *CampaignSendoutSplitInner) SetStatus(v string) {
	o.Status = &v
}

func (o CampaignSendoutSplitInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CampaignSendoutSplitInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Amount) {
		toSerialize["amount"] = o.Amount
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	return toSerialize, nil
}

type NullableCampaignSendoutSplitInner struct {
	value *CampaignSendoutSplitInner
	isSet bool
}

func (v NullableCampaignSendoutSplitInner) Get() *CampaignSendoutSplitInner {
	return v.value
}

func (v *NullableCampaignSendoutSplitInner) Set(val *CampaignSendoutSplitInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCampaignSendoutSplitInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCampaignSendoutSplitInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCampaignSendoutSplitInner(val *CampaignSendoutSplitInner) *NullableCampaignSendoutSplitInner {
	return &NullableCampaignSendoutSplitInner{value: val, isSet: true}
}

func (v NullableCampaignSendoutSplitInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCampaignSendoutSplitInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


